diff a/src/hotspot/cpu/x86/sharedRuntime_x86.cpp b/src/hotspot/cpu/x86/sharedRuntime_x86.cpp
--- a/src/hotspot/cpu/x86/sharedRuntime_x86.cpp
+++ b/src/hotspot/cpu/x86/sharedRuntime_x86.cpp
@@ -55,10 +55,15 @@
     __ xorptr(result, result);
     __ ret(0);
     __ bind(Continue);
   }
 
+  if (UseCompactObjectHeaders) {
+    // Don't generate anything else and always take the slow-path for now.
+    return;
+  }
+
   __ movptr(result, Address(obj_reg, oopDesc::mark_offset_in_bytes()));
 
 
   if (LockingMode == LM_LIGHTWEIGHT) {
     if (!UseObjectMonitorTable) {
